



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ovs之组网实验</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ovs之组网实验</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 18:20:30 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>介绍</h2>
<p>本示例将创建两个OVS实例和两个主机，其中每个OVS上接入一个主机，OVS实例之间有链路连接，形成一个链状拓扑，如图。在OVS组网完成之后，再通过手动方式添加流表，实现网络通信，从而验证实验可行性。具体步骤如下。<br /><br />
<img referrerpolicy="no-referrer"src="http://ww1.sinaimg.cn/large/94bdeb1fly1fyzbsblbcwj20va0em0sm.jpg"></p>
<h2>创建交换机</h2>
<pre class="prettyprint linenums"><code>root@mininet:~# ovs-vsctl add-br s1<br />
root@mininet:~# ovs-vsctl add-br s2<br />
</code></pre>
<h2>添加端口</h2>
<pre class="prettyprint linenums"><code>root@mininet:~# ovs-vsctl add-port s1 p1 #在交换机s1上添加port设置<br />
root@mininet:~# ovs-vsctl set Interface p1 ofport_request=10<br />
root@mininet:~# ovs-vsctl set Interface p1 type=internal<br />
</code></pre>
<p>同理，创建交换机sl上的端口p2，s2上的端口p3、p4。</p>
<pre class="prettyprint linenums"><code>root@mininet:~# ovs-vsctl add-port s1 p2<br />
root@mininet:~# ovs-vsctl set Interface p2 ofport_request=11<br />
root@mininet:~# ovs-vsctl set Interface p2 type=internal<br />
</code></pre>
<pre class="prettyprint linenums"><code>root@mininet:~# ovs-vsctl add-port s2 p3<br />
root@mininet:~# ovs-vsctl set Interface p3 ofport_request=1<br />
root@mininet:~# ovs-vsctl set Interface p3 type=internal<br />
</code></pre>
<pre class="prettyprint linenums"><code>root@mininet:~# ovs-vsctl add-port s2 p4<br />
root@mininet:~# ovs-vsctl set Interface p4 ofport_request=2<br />
root@mininet:~# ovs-vsctl set Interface p4 type=internal<br />
</code></pre>
<p>分别查看添加端口后的交换机<br /><br />
<img referrerpolicy="no-referrer"src="http://ww1.sinaimg.cn/large/94bdeb1fly1fyzbzpcih5j213d0kldhr.jpg"></p>
<h2>添加主机</h2>
<p>为了不影响网络中已有地址发生冲突，需要创建Namespace作为实验的终端主机。创建主机之后，需要为其设置虚拟IP，最后将其连接到OVS的数据端口，完成主机接入工作。本实验中，我们创建了hl和h2两个虚拟主机，设置IP分别为192.168.10.10和192.168.10.11，并将这两个主机分别接入到两个OVS实例上。</p>
<pre class="prettyprint linenums"><code>root@mininet:~# ip link set p4 netns h2<br />
root@mininet:~# ip netns exec h2 ip addr add 192.168.10.11/24 dev p4<br />
root@mininet:~# ip netns exec h2 ifconfig p4 promisc up

root@mininet:~# ip link set p1 netns h1<br />
root@mininet:~# ip netns exec h1 ip addr add 192.168.10.10/24 dev p1<br />
root@mininet:~# ip netns exec h1 ifconfig p1 promisc up

</code></pre>
<h2>创建交换机链路</h2>
<p>首先，需要将对应的端口设置为patch类型</p>
<pre class="prettyprint linenums"><code>root@mininet:~# ovs-vsctl set interface p2 type=patch<br />
root@mininet:~# ovs-vsctl set interface p3 type=patch<br />
</code></pre>
<p>创建p2到p3的内部链路，命令如下</p>
<pre class="prettyprint linenums"><code>root@mininet:~# ovs-vsctl set interface p2 options:peer=p3<br />
root@mininet:~# ovs-vsctl set interface p3 options:peer=p2<br />
</code></pre>
<p>最后，还需要向交换机添加对应的流表项，将交换机sl从10端口进入的数据转发到11端口，反向同理，s2操作同s1，具体操作如下。</p>
<pre class="prettyprint linenums"><code>root@mininet:~# ovs-ofctl add-flow s1 &quot;in_port=10,actions=output:11&quot;<br />
root@mininet:~# ovs-ofctl add-flow s1 &quot;in_port=11,actions=output:10&quot;<br />
root@mininet:~# ovs-ofctl add-flow s2 &quot;in_port=2,actions=output:1&quot;<br />
root@mininet:~# ovs-ofctl add-flow s2 &quot;in_port=1,actions=output:2&quot;<br />
</code></pre>
<p>创建完成之后，查看流表<br /><br />
<img referrerpolicy="no-referrer"src="http://ww1.sinaimg.cn/large/94bdeb1fly1fz03ve805vj20sv04lmxh.jpg"></p>
<p>在Network Namespace h1环境下执行ping 192.168.10.11的操作<br /><br />
<img referrerpolicy="no-referrer"src="http://ww1.sinaimg.cn/large/94bdeb1fly1fz03vmwaidj20q309b0tp.jpg"></p>
<p>ovs命令 <a href="https://blog.csdn.net/rocson001/article/details/73163041" rel="external nofollow noreferrer">https://blog.csdn.net/rocson001/article/details/73163041</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8oj32pq.html">Excel文件下载功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwrjvz9.html">单例模式（Java）</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8znmkv8.html">ServletContext总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k31g6q.html">Linux 高级网络编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm4dgz9.html">横版动作MOBA《超宇宙》首测试玩曝光 详解游戏特色（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k17yz69.html">IComparer&amp;lt&semi;T&amp;gt&semi; 接口Linq比较接口</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vopmo8.html">switch 与 whille相互套用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy16mx2q.html">NOIP2017SummerTraining0720</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzgxve8.html">linux nvme的那些workqueue</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey2noj9.html">LINUX改变文件大小</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj63mlq.html">java 轻量级同步volatile关键字简介与可见性有序性与synchronized区别 多线程中篇（十二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m6mg38.html">一个简单的go语言爬虫</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjjyv69.html">《Office 365开发入门指南》上市说明和读者服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o14241q.html">【2018&period;05&period;05 C与C&plus;&plus;基础】C&plus;&plus;中的自动废料收集：概念与问题引入</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1erl49.html">git 强制推送</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv22eg8.html">2017-12-15python全栈9期第二天第一节之昨日内容回顾</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2nj6x9.html">【ML】Two-Stream Convolutional Networks for Action Recognition in Videos</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w2n0gq.html">使用Python中的config配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvpmrg8.html">nginx给server增加日志配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2od4oq.html">CentOS下SSH远程免密登录服务器</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/90mz5mn8.html">从零学习Fluter&lpar;五&rpar;&colon;Flutter中手势滑动拖动已经网络请求</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z61l19.html">Android 屏幕适配插件 ScreenMatch</a>
			</li>
						<li><a href="https://www.batexi.com/a/93ye2nr8.html">window64位电脑如何通过VMware Workstation12&period;5&period;6安装苹果操作系统 macOS High Sierra 10&period;13</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eynlnj9.html">Session session &equals; connection&period;createSession&lpar;paramA&comma;paramB&rpar;&semi;参数解析</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jop0x8.html">SQLServer之数据类型解析</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzwwj48.html">Spring类型转换（Converter）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj11nz8.html">sqlalchemy外键的一些东西</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj16rr8.html">Win7 64位 &plus; LoadRunner 11录制时弹不出IE的解决办法 Win7 64位 &plus; LoadRunner 11录制时弹不出IE的解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojzxrxq.html">苹果手机连接Wifi认证机制</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kemj69.html">20175310 《Java程序设计》第9周学习总结</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
